# functions for computing integrals
int.s <- function(f, x, low = 0) {
 n <- length(x); x <- c(low, x)
 .C("integral_s", as.double(f), as.double(x),
  as.integer(n), val = double(n))$val
}

int1 <- function(x, f.val, low = 0) {
 n <- length(x); x <- c(low, x)
 if(length(f.val) != 3 * n) stop("input not match")
 res <- matrix(.C("integral_1", as.double(x),
  as.double(x), as.double(f.val), as.integer(n),
  as.integer(n), val = double(n * n))$val, ncol = n)
 apply(res, 1, cumsum)
}

int2 <- function(x, y, fx, fy, low.x = 0, low.y = 0) {
 nx <- length(x); ny <- length(y)
 if((length(fx) != 3 * nx) || (length(fy) != 3 * ny))
  stop("input not match")
 x <- c(low.x, x); y <- c(low.y, y)
 res <- matrix(.C("integral_2", as.double(x), as.double(y), 
  as.double(fx), as.double(fy), as.integer(nx), 
  as.integer(ny), val=double(nx*ny))$val, ncol=ny, byrow=T)
 apply(res, 2, cumsum)
}

int.f <- function(x, y, f, low = 0) {
 nx <- length(x); ny <- length(y); x <- c(low, x)
 res <- .C("integral_f", as.double(x),
  as.double(y), as.double(f), as.integer(nx),
  as.integer(ny), val=double(nx*ny))$val
 matrix(res, ncol=ny, byrow=F)
}

# diagComp function
diagComp <- function(mat, vec) {
 if (length(vec)==1) return(mat)
 len <- length(vec)
 cvec <- c(0, cumsum(vec))
 mlist <- as.list(1:len)
 mlist <- lapply(mlist, function(x,m,v) 
  if (nrow(m)>1) m[, (v[x] + 1):v[x + 1]]
  else matrix(m[,(v[x]+1):v[x+1]], nrow=1), 
   m=as.matrix(mat), v = cvec)
 bdiag(mlist)
}

