#include <stdio.h>
#include <math.h>

/**   cubic on [0, T]  **/
static double
rc(double x, double y) {
  double val, tmp;
  tmp=(x+y-fabs(x-y))/2.0;
  val=(tmp)*(tmp)*(3.0*(x+y-tmp)-tmp)/6.0;
  return(val);
}

void integral_1(double *x, double *y, double *f,
        long *n1, long *n2, double *res)
{
  long i,j, t, s;
  double x1, y1, sum=0.0, sum_tmp;

  for(i=0;i< *n1; i++){
    x1=x[i+1]-x[i];
    sum=0.0;
    for(j=0; j< *n2; j++){
      y1=y[j+1]-y[j];
     sum_tmp= 0.2777778*0.2777778*(f[3*i]*f[3*j])*     rc(x[i]+x1*0.1127017, y[j]+y1*0.1127017)+
              0.2777778*0.4444444*((f[3*i]*f[3*j+1])*  rc(x[i]+x1*0.1127017, y[j]+y1*0.5      )+
 	           	           (f[3*i+1]*f[3*j])*  rc(x[i]+x1*0.5,       y[j]+y1*0.1127017));
     sum_tmp+=0.4444444*0.4444444*((f[3*i+1]*f[3*j+1])*rc(x[i]+x1*0.5,       y[j]+y1*0.5))+
              0.2777778*0.2777778*((f[3*i+2]*f[3*j+2])*rc(x[i]+x1*0.8872983, y[j]+ y1*0.8872983));
     sum_tmp+=  0.2777778*0.2777778*((f[3*i]*f[3*j+2])*rc(x[i]+x1*0.1127017, y[j]+y1*0.8872983)+
                                     (f[3*i+2]*f[3*j])*rc(x[i]+x1*0.8872983, y[j]+y1*0.1127017))+
              0.4444444*0.2777778*((f[3*i+1]*f[3*j+2])*rc(x[i]+x1*0.5,       y[j]+y1*0.8872983)+
                                   (f[3*i+2]*f[3*j+1])*rc(x[i]+x1*0.8872983, y[j]+y1*0.5));  

      sum+=sum_tmp*x1*y1;  
      res[i*(*n2)+j]=sum;  
    }
  }
}


void integral_2(double *x, double *y, double *fx, double *fy,
        long *n1, long *n2, double *res)
{
  long i,j, t, s;
  double x1, y1, sum=0.0, sum_tmp;

  for(i=0;i< *n1; i++){
    x1=x[i+1]-x[i];
    sum=0.0;
    for(j=0; j< *n2; j++){
      y1=y[j+1]-y[j];
     sum_tmp= 0.2777778*0.2777778*(fx[3*i]*fy[3*j])*     rc(x[i]+x1*0.1127017, y[j]+y1*0.1127017)+
              0.2777778*0.4444444*((fx[3*i]*fy[3*j+1])*  rc(x[i]+x1*0.1127017, y[j]+y1*0.5      )+
 	           	           (fx[3*i+1]*fy[3*j])*  rc(x[i]+x1*0.5,       y[j]+y1*0.1127017));
     sum_tmp+=0.4444444*0.4444444*((fx[3*i+1]*fy[3*j+1])*rc(x[i]+x1*0.5,       y[j]+y1*0.5))+
              0.2777778*0.2777778*((fx[3*i+2]*fy[3*j+2])*rc(x[i]+x1*0.8872983, y[j]+ y1*0.8872983));
     sum_tmp+=  0.2777778*0.2777778*((fx[3*i]*fy[3*j+2])*rc(x[i]+x1*0.1127017, y[j]+y1*0.8872983)+
                                     (fx[3*i+2]*fy[3*j])*rc(x[i]+x1*0.8872983, y[j]+y1*0.1127017))+
              0.4444444*0.2777778*((fx[3*i+1]*fy[3*j+2])*rc(x[i]+x1*0.5,       y[j]+y1*0.8872983)+
                                   (fx[3*i+2]*fy[3*j+1])*rc(x[i]+x1*0.8872983, y[j]+y1*0.5));  

      sum+=sum_tmp*x1*y1;  
      res[i*(*n2)+j]=sum;  
    }
  }
}

void integral_f(double *x, double *y, double *f,
        long *nx, long *ny, double *res)
{
  
  long i,j;
  double x1, y1, sum=0.0;

  for(i=0;i< *ny; i++){
    sum=0.0;    
    for(j=0; j< *nx; j++){
      x1=x[j+1]-x[j];
      sum+=x1*(0.2777778*(f[3*j]*  rc(x[j]+x1*0.1127017, y[i])+
                      f[3*j+2]*rc(x[j]+x1*0.8872983, y[i]))+
           0.4444444* f[3*j+1]*rc(x[j]+x1*0.5,       y[i]));      
      res[i*(*nx)+j]=sum;  
    }
  }
}


void integral_s(double *f, double *x, long *n, double *res)
{
  long i;
  double sum=0.0;

  for(i=0;i< *n; i++){ 
    sum += (x[i+1]-x[i])*(0.2777778*(f[3*i]+f[3*i+2])+0.4444444*f[3*i+1]);      
    res[i]=sum;
  }
}
