# Code for USA climate data

library(assist)
library(akima)
library(maps)
data(USAtemp)
attach(USAtemp)

# fit a TPS
fit <- ssr(temp~long+lat,rk=tp.pseudo(list(long,lat))) 
i <- interp(long,lat,temp,xo=seq(min(long),max(long),len=60),
            yo=seq(min(lat),max(lat),len=60)) 
grid <- list(long=i$x,lat=i$y) 
p <- predict(fit, expand.grid(grid), pstd=F) 
postscript("usawa1.ps",height=3,width=4.75,horizontal=F,pointsize=8) 
par(mar=c(1,1,1,1)+0.1)
z <- matrix(p$fit, length(i$x), length(i$y)) 
z[is.na(i$z)] <- NA
z <- -z
lv <- seq(-70,-10,by=5)
lv1 <- seq(70,10,by=-5)
filled.contour(grid$long, grid$lat, z, axes=F, frame.plot=F,
  col=gray(c(seq(1,.5,len=11),0)),  
  levels=lv, key.axes=axis(2,lv,labels=as.character(lv1)))
dev.off() 

