# Code for world climate data

library(assist)
library(maps)
data(climate)

fit <- ssr(temp~1, rk=sphere(cbind(long,lat)), data=climate)
ngrid <- 60
long.grid <- seq(0,2*pi,len=ngrid)
lat.grid <- seq(-pi/2,pi/2,len=ngrid)
p <- predict(fit,expand.grid(long=long.grid,
             lat=lat.grid),pstd=F)
x <- (long.grid-pi)*180/pi
y <- lat.grid*180/pi
postscript("worldtemp.ps",height=4,width=4.5,horizontal=F,pointsize=8)
par(mgp=c(2,1,0), mar=c(3,3,1,1)+.1)

contour(x,y,matrix(p$fit,ncol=ngrid),nlevels=20,
        xlab="longitude",ylab="latitude")
map(add=T,interior=F)
dev.off()
	
